// Путь к каталогу с картинками
var imagePath = 'images/';
// Наименования картинок для элементов
if(typeof itemPics == 'undefined'){
    var itemPics = ['c1-f.png', 'c2-f.png', 'c3-f.png', 'c4-f.png', 'c5-f.png', 'c6-f.png'];
}
var bangPic  = 'explosion.png';

// Количество элементов. Можно изменять сложность, уменьшая его. Не может быть больше длины массива itemPics
var itemCount = itemPics.length;
// Размеры изображения
var dimW = 64;
var dimH = 64;

// Размеры игрового поля
var dimX = 6;
var dimY = 6;

// Пропорции игрового поля (какую часть от размера окна занимает поле)
var gameFieldRX = 0.8; // в ширину
var gameFieldRY = 0.8; // в высоту


/* =========== Игровая система ============= */

var difficulty = 2;
var pts_min = 200;		// Количество очков за три-в-ряд
var k_pts   = 0.75;		// Коэффициент умножения очков при четыре- или пять-в-ряд

var moves_lvl = 20;		// Количество ходов
var moves_incr = 1;		// Увеличения ходов при четыре- или пять-в-ряд
var k_moves    = 0.9;		// Коэффициент убывания очков при повышении уровня

var pts_lvl = 500;		// Количество очков для перехода на новый уровень
var k_lvl   = 1.2;		// Коэффициент увеличения очков для следующего уровня

if(typeof difficulty != 'undefined'){
    if(difficulty == 0){
        moves_lvl = 40;
        k_moves = 1;
        k_lvl   = 1.1;
    } else if(difficulty == 1){
        moves_lvl = 20;
        k_moves = 0.9;
        k_lvl   = 1.2;
    } else if(difficulty == 2){
        moves_lvl = 10;
        k_moves = 0.7;
        k_lvl   = 1.5;
    }
}

var GF;                         // Представитель класса "Игровое поле"

// Класс "Игровое поле" - ответственен за прорисовку рабочей области и управление элементами
function GameField(canvID, tableID, savescore)
{
    this.prototypes		= [];
    this.proto_expl		= 0;
    this.rasters		= [];
    this.rasters_pre	= [];
    this.rasters_post	= [];
    this.drag		= false;
    this.dragblock		= false;
    this.drag_mode		= 0;
    this.delta_abs		= 0;
    this.delta_aft		= 0;

    // ????????? ??????????, ? ??????? ?????? ??????????????
    this.startX		= 0;
    this.startY		= 0;

    // ??????? ?????????? ?????????????? (??? ??????????? ???????)
    this.currentX		= 0;
    this.currentY		= 0;

    this.fieldI		= 0;
    this.fieldJ		= 0;

    this.onResize = function ()
    {
        if (this.drag)
        {
            window.setTimeout($.proxy(this.onResize, this), 2000);
            return false;
        }

        this.SizeSetup();

        this.scale = this.getScale();

        this.fieldY = $('#'+this.id).position().top;
        this.ResetField()

    }
    this.ResetField = function()
    {
        for (var i=0; i<dimY; i++)
            for (var j=0; j<dimX; j++)
            {
                this.scaleItem(i, j);
            }
    }
    this.SizeSetup = function()
    {
        var winW = $(window).width();
        var winH = $(window).height();

        var k_width  =  winW * gameFieldRX / (dimX * dimW);
        var k_height =  winH * gameFieldRY / (dimY * dimH);

        var k = k_width > k_height ? k_height : k_width;
        //console.log(winW+' * '+ gameFieldRX + ' / ' + (dimX * dimW) + ' = ' + k_width + '   &&&   ' + winH+' * '+ gameFieldRY + ' / ' + (dimY * dimH) + ' = ' + k_height + ' &&&&& ' + k);

        $('#'+this.id).width(dimX * dimW * k);
        $('#'+this.id).height(dimY * dimH * k);
        this.fieldX = ($(window).width() - $('#'+this.id).width())/2
        $('#'+this.id).css('margin-left', this.left);

//        $('#'+this.table).width(dimX * dimW * k);
//        $('#'+this.table+' div').width(dimX * dimW * k/2);
    }
    this.getScale = function ()
    {
        var k_width  =  $('#'+this.id).width() / (dimX * dimW); // paper.view.size.width
        var k_height =  $('#'+this.id).height() / (dimY * dimH);

        console.log('SCALE: w: '+$('#'+this.id).width()+' /  '+(dimX * dimW) +' = '+ k_width + ' &&&  h: '+$('#'+this.id).height()+' / '+(dimY * dimH)+ ' = ' + k_height);
        return k_width > k_height ? k_height:k_width;
    }
    this.ClearField = function()
    {
        var currentItem;
        for (var i=0; i<dimY; i++)
            for (var j=0; j<dimX; j++)
            {
                currentItem = this.game.GetMatrix(i, j);
                if (currentItem)
                {
                    $('#gi'+'-'+i+'-'+j).css({'background-image': 'url(\''+imagePath + bangPic+'\')', 'background-size': 'cover'});
                }
                this.drag_block = true;
            }
        window.setTimeout($.proxy(this.onFire, this), 500);
    }
    this.onFire = function()
    {
        var currentItem;
        this.game.RenewField();
        for (var i=0; i<dimY; i++)
            for (var j=0; j<dimX; j++)
            {
                currentItem = this.game.GetMatrix(i, j);
                if (currentItem)
                {
                    currentItem = this.game.GetItem (i, j);
                    $('#gi'+'-'+i+'-'+j).css({'background-image': 'url(\''+imagePath + itemPics[currentItem]+'\')', 'background-size': 'cover'});
                }
            }
        this.drag_block = false;
    }
    this.ElementShift = function(mode, shift_count, index)
    {
        var ind		= 0;
        var shift	= 0;
        var arr_length	= mode == 1 ? dimX : dimY;
        var inc		= shift_count > 0? -1:1;

        if (shift_count != 0)
        {

            this.game.ElementShift(mode, shift_count, index);
        }

    }
    this.GetCoord = function(coord, position)
    {
        var sizeReal = (coord=='x'? dimW : dimH) * this.scale;
        var sizeHalf = Math.round(sizeReal / 2);
        return sizeReal*position/* + sizeHalf*/;
    }
    this.drawItem = function (gameItem, offset_y, offset_x, parent, prefix)
    {
        prefix = prefix || 'gi';
        var html = '<div class="gameitem" id="'+prefix+'-'+offset_y+'-'+offset_x+'"></div>';
        $(parent).append(html);
        $('#'+prefix+'-'+offset_y+'-'+offset_x).css({'background-image': 'url(\''+imagePath + itemPics[gameItem]+'\')', 'background-size': 'cover'});
    }
    this.scaleItem = function(i, j)
    {
        $('#gi-'+i+'-'+j).css({'left': this.GetCoord('x', j)+this.fieldX, 'top': this.GetCoord('y', i)+this.fieldY});
        $('#gi-'+i+'-'+j).css({'width': dimW*this.scale, 'height': dimH*this.scale});
        //console.log('X: '+(this.GetCoord('x', j)+this.fieldX)+'Y: '+(this.GetCoord('y', i)+this.fieldY));
    }

    this.drawGameField = function ()
    {
        var gameItem;
        for (var i=0; i<dimY; i++)
        {
            this.rasters[i] = [];
            for (var j=0; j<dimX; j++)
            {
                gameItem = this.game.GetItem (i, j);
                this.rasters[i][j] = this.drawItem(gameItem, i, j, '#'+this.id);
                //this.rasters[i][j].scale(this.scale);
            }
        }
    }
    this.GetDragPoints = function(X, Y)
    {
        var widthReal = dimW*this.scale;
        var widthHalf = Math.round(widthReal / 2);
        var heightReal = dimH*this.scale;
        var heightHalf = Math.round(heightReal / 2);

        this.fieldI	= Math.floor((Y-this.fieldY)/heightReal);
        this.fieldJ     = Math.floor((X-this.fieldX)/widthReal);

        if (this.fieldI < 0)
            this.fieldI = 0;
        else if (this.fieldI > dimY-1)
            this.fieldI = dimY - 1;

        if (this.fieldJ < 0)
            this.fieldJ = 0;
        else if (this.fieldJ > dimX-1)
            this.fieldJ = dimX - 1;

        //console.log ('DRAG: Y: '+Y+'-'+this.fieldY+' / '+heightReal+' = '+this.fieldI+' ; X: '+X+'-'+this.fieldX+' / '+widthReal+' = '+this.fieldJ);
    }
    this.DragStart = function (X, Y)
    {

        if (!this.drag && !this.drag_block)
        {
            console.log('GRABBED');
            this.drag	= true;
            this.startX	= X;
            this.startY	= Y;
            this.delta_abs	= 0;

            this.GetDragPoints(X, Y);
        }
    }
    this.onDragStart = function (event)
    {
        this.DragStart(event.pageX, event.pageY);
        return false;
    }
    this.onTouchStart = function (event)
    {
        var touch = event.originalEvent.touches[0] || event.originalEvent.changedTouches[0];
        this.DragStart(touch.pageX, touch.pageY);
        return false;
    }
    this.DragEnd = function ()
    {
        var time;
        var coord;
        var I	= this.fieldI;
        var J	= this.fieldJ;
        if (!this.drag) return;
        console.log('RELEASED');
        if (this.drag_mode == 1)
        {
            this.GetDragPoints(this.currentX, this.currentY);
            J = this.fieldJ - J;
            this.fieldI = I;
            this.ElementShift(1, J, this.fieldI);

            for (var j=0; j<dimX; j++)
            {
                currentItem = this.game.GetItem (I, j);
                $('#gi'+'-'+I+'-'+j).css({'background-image': 'url(\''+imagePath + itemPics[currentItem]+'\')', 'background-size': 'cover'});
                $('#gi'+'-'+I+'-'+j).css('display', 'block');
            }
            $('#move-horiz').remove();

            if (J)
            {
                this.game.Move(this.drag_mode);
                this.game.GetScore(this.drag_mode);
                this.game.SetTable();

                this.ClearField();
            }
        }
        else if (this.drag_mode == 2)
        {
            this.GetDragPoints(this.currentX, this.currentY);
            I = this.fieldI - I;
            this.fieldJ = J;
            this.ElementShift(2, I, this.fieldJ);
            for (var i=0; i<dimY; i++)
            {
                currentItem = this.game.GetItem (i, J);
                $('#gi'+'-'+i+'-'+J).css({'background-image': 'url(\''+imagePath + itemPics[currentItem]+'\')', 'background-size': 'cover'});
                $('#gi'+'-'+i+'-'+J).css('display', 'block');
            }
            $('#move-vert').remove();
            if (I)
            {
                this.game.Move(this.drag_mode);
                this.game.GetScore(this.drag_mode);
                this.game.SetTable();
                this.ClearField();
            }
        }
        this.drag = false;
        this.drag_mode = 0;

    }
    this.onDragEnd = function(event)
    {
        this.currentX	= event.pageX;
        this.currentY	= event.pageY;
        this.DragEnd();
    }
    this.onTouchEnd = function(event)
    {
        var touch = event.originalEvent.touches[0] || event.originalEvent.changedTouches[0];

        this.currentX	= touch.pageX;
        this.currentY	= touch.pageY;
        this.DragEnd();
    }
    this.DragMove = function()
    {
        var currentItem;
        var chk = '';
        var line = '';
        var sizeReal;
        if (!this.drag_mode)
        {
            if (Math.abs(this.currentX - this.startX) >= Math.abs(this.currentY - this.startY))
            {
                this.drag_mode = 1;
                $('#'+this.id).append('<div id="move-horiz" style="position: absolute; overflow: hidden;"></div');
                $('#move-horiz').css({'left': this.GetCoord('x', 0)+this.fieldX, 'top': this.GetCoord('y', this.fieldI)+this.fieldY, 'width': (dimW*dimX*this.scale)+'px', 'height': dimH*this.scale});
                $('#move-horiz').on('mouseout', $.proxy(this.onDragEnd, this));
                for (var j=-dimX; j<2*dimX; j++)
                {
                    if (j>=0 && j<dimX)
                        $('#gi-'+this.fieldI+'-'+j).css('display', 'none');

                    currentItem = this.game.GetItem(this.fieldI, j<0?(j+dimX):(j<dimX?j:j-dimX));
                    chk += ' '+currentItem;
                    this.drawItem(currentItem, this.fieldI, j, '#move-horiz', 'move');
                    $('#move-'+this.fieldI+'-'+j).css({'left': this.GetCoord('x', j), 'top': 0});
                    $('#move-'+this.fieldI+'-'+j).css({'width': dimW*this.scale, 'height': dimH*this.scale});
                    $('#move-'+this.fieldI+'-'+j).addClass('moving');

                }
                //console.log(chk);
            }
            else
            {
                this.drag_mode = 2;
                $('#'+this.id).append('<div id="move-vert" style="position: absolute; overflow: hidden;"></div');
                $('#move-vert').css({'left': this.GetCoord('x', this.fieldJ)+this.fieldX, 'top': this.GetCoord('y', 0)+this.fieldY, 'width': (dimW*this.scale)+'px', 'height': dimH*dimY*this.scale});
                $('#move-horiz').on('mouseout', $.proxy(this.onDragEnd, this));
                for (var i=-dimX; i<2*dimY; i++)
                {
                    if (i>=0 && i<dimY)
                        $('#gi-'+i+'-'+this.fieldJ).css('display', 'none');

                    currentItem = this.game.GetItem(i<0?(i+dimY):(i<dimY?i:i-dimY), this.fieldJ);
                    chk += ' '+currentItem;
                    this.drawItem(currentItem, i, this.fieldJ, '#move-vert', 'move');
                    $('#move-'+i+'-'+this.fieldJ).css({'left': 0, 'top': this.GetCoord('y', i)});
                    $('#move-'+i+'-'+this.fieldJ).css({'width': dimW*this.scale, 'height': dimH*this.scale});
                    $('#move-'+i+'-'+this.fieldJ).addClass('moving');

                }

            }
        }
        if (this.drag_mode == 1)
        {
            delta =  this.currentX - this.startX;
            this.delta_abs += delta;

            sizeHalf = dimW * this.scale/2;
            limit = (delta > 0 ? $('#'+this.id).width()-sizeHalf:sizeHalf);

            //console.log(this.rasters[this.fieldI][this.fieldJ].position.x+'+'+delta+' ? '+limit);

            if(this.currentX-this.fieldX<=limit && delta > 0 || this.currentX-this.fieldX >=limit && delta < 0)
                $('#move-horiz .moving').css({'-webkit-transform': 'translate3d('+(delta)+'px, 0px, 0px)', '-webkit-transition': 'none'});
            console.log((this.currentX-this.fieldX)+' =? '+limit);

        }
        else if (this.drag_mode == 2)
        {
            delta =  this.currentY - this.startY;
            this.delta_abs += delta;
            sizeHalf = dimH * this.scale /2;
            limit = (delta > 0 ? $('#'+this.id).height()-sizeHalf:sizeHalf);

            //console.log(this.rasters[this.fieldI][this.fieldJ].position.x+'+'+delta+' ? '+limit);

            if(this.currentY-this.fieldY<=limit && delta > 0 || this.currentY-this.fieldY >=limit && delta < 0)
                $('#move-vert .moving').css({'-webkit-transform': 'translate3d(0px, '+(delta)+'px, 0px)', '-webkit-transition': 'none'});
        }

    }
    this.onTouchMove = function(event)
    {
        var delta;
        var space;
        if (this.drag)
        {
            var touch = event.originalEvent.touches[0] || event.originalEvent.changedTouches[0];
            this.currentX	= touch.pageX;
            this.currentY	= touch.pageY;
            this.DragMove();
        }
        return false;
    }

    this.onMouseMove = function(obj)
    {
        var delta;
        var space;
        if (this.drag)
        {
            this.currentX	= obj.pageX;
            this.currentY	= obj.pageY;
            this.DragMove();
        }
        return false;
    }
    this.SaveScore = function()
    {
        var score = new Scores();
        score.SaveScore($('#'+this.saveform+' #name').val(), $('#'+this.saveform+' #gotscore').text());
        document.location = 'scores.html';
    }

    this.id = canvID;
    this.table = tableID;
    this.saveform= savescore;
    this.canvas = document.getElementById(canvID);
    this.SizeSetup();
    this.scale = this.getScale();
    this.game = new GameLogic(this, tableID);

    this.fieldX = $('#'+this.id).offset().left;
    this.fieldY = $('#'+this.id).offset().top;

    $('#'+this.id).on('mousedown', $.proxy(this.onDragStart, this));
    $('#'+this.id).on('mouseup', $.proxy(this.onDragEnd, this));
    $('#'+this.id).on('mousemove', $.proxy(this.onMouseMove, this));

    $('#'+this.id).on('touchstart', $.proxy(this.onTouchStart, this));
    $('#'+this.id).on('touchend', $.proxy(this.onTouchEnd, this));
    $('#'+this.id).on('touchmove', $.proxy(this.onTouchMove, this));

    $('#'+this.saveform+' #savescore').click( $.proxy(this.SaveScore, this));
    $(window).resize($.proxy(this.onResize, this));

    this.drawGameField();
    this.ResetField();
}

// ????? ? ??????? ???????
function GameLogic(parent, table)
{
    this.field	= null;
    this.matrix	= [];
    this.table	= table;
    this.parent	= parent;
    this.moves	= moves_lvl;
    this.moves_inc  = moves_lvl;
    this.points	= 0;
    this.nextlevel	= pts_lvl;
    this.level	= 0;

    this.ResetField = function ()
    {
        this.field = [];
        for (var i=0; i<dimY; i++)
        {
            this.field[i] = [];
            for (var j=0; j<dimX; j++)
                this.field[i][j] = -1;
        }
    }
    this.SetTable = function()
    {
        $('#'+this.table+' #moves').text(this.moves);
        $('#'+this.table+' #points').text(this.points);
        $('#'+this.table+' #levelup').text(this.nextlevel);
        $('#'+this.table+' #level').text(this.level);

    }
    this.GetScore = function(mode)
    {
        var len_i	= mode == 1 ? dimX : dimY;
        var len_j	= mode == 2 ? dimX : dimY;
        var count	= 0;
        for (var i=0; i<len_i; i++)
            for (var j=0; j<len_j; j++)
            {
                if (this.matrix[i][j])
                {
                    count ++;
                    //console.log('+++: ['+i+']['+j+']');
                }
            }
        //console.log('COUNTING POINTS: '+count);
        if (count > 0)
        {
            count-=3;
            this.moves +=count;
            this.points += Math.ceil(count * k_pts * pts_min)+pts_min;

            if (this.points >= this.nextlevel)
            {
                this.level++;
                this.nextlevel += Math.ceil(this.nextlevel * k_lvl);
                this.moves_inc = this.moves_inc*k_moves;
                this.moves += Math.round(this.moves_inc);
            }
        }
        if (this.moves == 0)
            this.GameOver();
    }
    this.GameOver = function()
    {
        $('#gotscore').text(this.points);
        $('#gotlevel').text(this.level);
        $('#screen').css('display', 'block');
        $('canvas').css('display', 'none');
        $('#screen').animate({opacity: 1}, 1000);
        $('#main').animate({opacity: 0}, 1000);
        $('#gametable').css('display', 'none');
    }
    this.ClearMatrix = function()
    {
        var maxlen = dimX > dimY? dimX:dimY;
        for (var i=0; i<maxlen; i++)
        {
            this.matrix[i] = [];
            for (var j=0; j<maxlen; j++)
                this.matrix[i][j] = 0;
        }
    }
    this.GetMatrix = function(ind_i, ind_j)
    {
        return this.matrix[ind_i][ind_j];
    }
    this.MarkMatrix = function(mode, index, pos, count)
    {
        var arr_len_i = mode == 1 ? dimX : dimY;
        var arr_len_j = mode == 2 ? dimX : dimY;
        for (var ind=0; ind<arr_len_i; ind++)
        {
            for (var jnd=0; jnd< arr_len_j; jnd++)
            {
                if (ind == index && jnd >= pos && jnd < pos + count)
                {
                    //console.log('MARKING: '+(mode == 1? jnd : ind)+' and '+(mode == 2 ? jnd : ind));

                    this.matrix[mode == 1? jnd : ind][mode == 2 ? jnd : ind] = 1;
                }
            }

        }
    }
    this.Move = function(mode)
    {
        var count	= 0;
        var pos		= 0;
        var el		= 0;
        var len_i	= mode == 1 ? dimX : dimY;
        var len_j	= mode == 2 ? dimX : dimY;
        var ind_i, ind_j;
        this.moves--;
        this.ClearMatrix();
        for (var i=0; i<len_i; i++)
        {
            ind_i = mode == 1 ? i : 0;
            ind_j = mode == 2 ? i : 0;
            el = this.field[ind_i][ind_j];
            count = 0;
            pos = 0;
            for (var j=0; j<len_j; j++)
            {
                ind_i = mode == 1 ? j : i;
                ind_j = mode == 2 ? j : i;
                //console.log('field['+ind_i+']['+ind_j+']='+this.field[ind_i][ind_j]+' && el='+el+' && count = '+count);
                if (this.field[ind_i][ind_j] == el) count ++;
                else
                {
                    if (count >=3)
                        this.MarkMatrix(mode, i, pos, count);
                    count = 1;
                    el = this.field[ind_i][ind_j];
                    pos = j;
                }

            }
            if (count >=3)
                this.MarkMatrix(mode, i, pos, count);

        }
        el = this.field[mode == 1 ? this.parent.fieldI : 0][mode == 2 ? this.parent.fieldJ : 0];
        count = 0;
        pos   = 0;  console.log();
        for (var i=0; i<len_i; i++)
        {
            ind_i = mode == 1 ? this.parent.fieldI : i;
            ind_j = mode == 2 ? this.parent.fieldJ : i;
            if (this.field[ind_i][ind_j] == el) count ++;
            else
            {
                if (count >=3)
                    this.MarkMatrix(mode == 1 ? 2:1, mode == 1 ? this.parent.fieldI:this.parent.fieldJ, pos, count);
                count = 1;
                el = this.field[ind_i][ind_j];
                pos = i;
            }
        }
        if (count >=3)
            this.MarkMatrix(mode == 1 ? 2:1, mode == 1 ? this.parent.fieldI:this.parent.fieldJ, pos, count);
    }
    this.ElementShift = function(mode, count, index)
    {
        var arr_length	= mode == 1 ? dimX : dimY;
        var ind		= count > 0 ? arr_length - 1 : 0;
        var inc		= count > 0? -1:1;
        var j		= 0;
        var buff	= [];

        do
        {
            //console.log('BUFFERING buff['+j+'] from field['+(mode == 1 ? index : ind+j*inc)+']['+(mode == 2 ? index : ind+j*inc)+']');
            buff[j] = this.field[mode == 1 ? index : ind+j*inc][mode == 2 ? index : ind+j*inc];
            j++;
        }	while (j != Math.abs(count));

        ind	= count > 0 ? arr_length - 1 : 0;

        do
        {
            //console.log('COPYING field['+(mode == 1 ? index:ind)+']['+(mode == 2? index:ind)+'] from field['+(mode == 1 ? index : ind + Math.abs(count)*inc)+']['+(mode == 2 ? index : ind + Math.abs(count)*inc)+']');
            this.field[mode == 1 ? index:ind][mode == 2? index:ind] = this.field[mode == 1 ? index : ind + Math.abs(count)*inc][mode == 2 ? index : ind + Math.abs(count)*inc];
            ind+= inc;
        }	while (ind-Math.abs(count) >= 0 && count > 0 || ind + Math.abs(count) < arr_length && count < 0);

        for (var i=0; i<Math.abs(count); i++)
        {
            if (count > 0)
            {
                //console.log('RESTORING + field['+(mode == 1 ? index : i)+']['+(mode == 2 ? index : i)+'] from buff['+(Math.abs(count)-1-i)+']');
                this.field[mode == 1 ? index : i][ mode == 2 ? index : i] = buff[Math.abs(count)-1-i];
            }
            else
            {
                //console.log('RESTORING - field['+(mode == 1 ? index : arr_length - 1 - i)+']['+(mode == 2 ? index : arr_length - 1 - i)+'] from buff['+(i)+']');
                this.field[mode == 1 ? index : arr_length - 1 - i][mode == 2 ? index : arr_length - 1 - i] = buff[Math.abs(count)-1-i];
            }
        }

    }
    this.FillField = function ()
    {
        for (var i=0; i<dimY; i++)
            for (var j=0; j<dimX; j++)
                this.field[i][j] = this.GetRandomItem(i, j);
    }
    this.RenewField = function()
    {
        for (var i=0; i<dimY; i++)
            for (var j=0; j<dimX; j++)
                if (this.matrix[i][j])
                    this.field[i][j] = this.GetRandomItem(i, j);
    }
    this.GetItem = function(index_row, index_col)
    {
        //console.log('FIELD['+index_row+']['+index_col+'] = '+this.field[index_row][index_col]);
        return this.field[index_row][index_col];
    }

    this.GetRandomItem = function(index_row, index_col)
    {
        var rand;
        var count = 20;
        do
        {
            rand = Math.floor(Math.random() * itemCount);
            count--;
        }
        while(this.ElementMatch(rand, index_row, index_col, 1) || this.ElementMatch(rand, index_row, index_col, 2));
        return rand;
    }
    this.ElementMatch = function (elem, index_row, index_col, direction)
    {
        var elementCount = 0;
        var limit        = direction == 1 ? this.field[index_row].length : this.field.length;
        var point        = direction == 1 ? index_col : index_row;

        for (var index = 0; index < limit; index++)
            if (index >= point - 2 && index <=point + 2 && index != point)
            {

                if (this.field[direction == 2 ? index : index_row][direction == 1 ? index : index_col] == elem)
                    elementCount ++;
                else
                {
                    if (elementCount >=3) break;
                    else elementCount = 0;
                }
            }
            else if (index == point)
                elementCount ++;
        return elementCount >= 3 ? elementCount : false;
    }

    this.ResetField();
    this.FillField();
    this.SetTable();
}
$(window).ready(function()
{
    var GF = new GameField('gamefield', 'gametable', 'form');

});