var scorecount = 10;

function isInApp(){
	return typeof AppsgeyserJSInterface != 'undefined';
}

function getAppId(){
	if(isInApp()){
		return AppsgeyserJSInterface.getAppId();
	}
	return 1;
}

function getInstallationGuid(){
	if(isInApp()){
		return AppsgeyserJSInterface.getInstallationGuid();
	}
	return '{00000000-0000-0000-0000-000000000000}';
}

function Scores()
{
	this.names = [];
	this.scores = [];
	this.stamp = [];

	this.fetchScores = function(callback){
		$('.loading').show();
		$.ajax({
			url: 'http://54.243.57.80',
			data: {
				appid:getAppId(),
				installation_guid:getInstallationGuid(),
				method: 'get'
			},
			type: 'get',
			dataType:'jsonp',
			crossDomain:true,
			success: function(json){
				if(typeof callback == 'function') callback(json.leaderBoard);
			},
			error: function(e){
				//showError('Error loading leaderboard... Check your connection.'); TODO
				console.log("Ajax error: " + e.status + " " + e.statusText);
			},
			complete: function(){
				$('.loading').hide();
			}
		});
	};

	this.showScores = function()
	{
		this.fetchScores(function(leaderBoard){
			var top = leaderBoard.top||[];
			var $table = $('#scores');
			$table.find('.score-element:not(.row-template)').remove();
			for(var i in top){
				if(!top.hasOwnProperty(i)) continue;
				var $row = $('.row-template').clone();
				$row.removeClass('row-template');
				$row.attr('position',top[i].position);
				$row.find('.scores-name').text(top[i].name);
				$row.find('.scores-number').text(top[i].score);
				$table.append($row);
			}
			var near = leaderBoard.near||[];
			for(i in near){
				if(!near.hasOwnProperty(i)) continue;
				var $rowFound = $('.score-element[position='+near[i].position+']');
				if($rowFound.length){
					$row = $rowFound;
				} else {
					$row = $('.row-template').clone();
					$table.append($row);
				}
				$row.removeClass('row-template');
				$row.attr('position',near[i].position);
				$row.find('.scores-name').text(near[i].name);
				$row.find('.scores-number').text(near[i].score);
				if(near[i].you) $row.addClass('lastitem');
			}

			var $rows = $table.find('.score-element:not(.row-template)');
			if(!$rows.length){
				$row = $('.row-template').clone();
				$row.removeClass('row-template');
				$row.find('.scores-name').text("No scores yet...");
				$table.append($row);
			} else {
				for(i = 1; i < $rows.length; i++){
					if($rows.eq(i).attr('position') - 1 != $rows.eq(i-1).attr('position')){
						$row = $('.row-template').clone();
						$row.removeClass('row-template');
						$row.find('.scores-name').text("...");
						$rows.eq(i-1).after($row);
						break;
					}
				}
		}
		});
	};


	this.SaveScore = function(name, points,callback)
	{
		$('.loading').show();
		$.ajax({
			url: 'http://54.243.57.80',
			data: {
				appid:getAppId(),
				installation_guid:getInstallationGuid(),
				score:points,
				user_name:name,
				method : 'post'
			},
			type: 'post',
			dataType:'jsonp',
			crossDomain:true,
			success: function(json){
				if(!json.submitted){
					//showError('Error submitting your score.'); TODO
					return;
				}
				$('.send-score').hide();
			},
			error: function(e){
				//showError('Error submitting your score.'); TODO
			},
			complete: function(){
				$('.loading').hide();
				if(typeof callback=='function') callback();
			}
		});
	};

	this.ResetScores = function()
	{
	};
}
